/* CCS, Class Collection by Sakurai
 *	Copyright (C) 2000-2001 SAKURAI, Masashi (m.sakurai@cmt.phys.kyushu-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.ccs2.comp;
import java.awt.Component;
import java.awt.event.FocusEvent;
import java.awt.event.FocusAdapter;
import java.awt.im.InputSubset;

/** The special focus event listener that activate KANJI IME. */
public class IMEFocusListener extends FocusAdapter {

	/** FocusAdapter stuff (activate IME) */
	public void focusGained(FocusEvent event) {
		activateIME(event.getComponent(),true);
	}

	/** FocusAdapter stuff (deactivate IME) */
	public void focusLosted(FocusEvent event) {
		activateIME(event.getComponent(),false);
	}

	/** IME utility 
	 * @param c target component object
	 * @param kanji if true, activate the IME on the component.
	 */
	public static void activateIME(Component c,boolean kanji) {
		if (kanji) {
			c.getInputContext().setCharacterSubsets
				(new Character.Subset[] {InputSubset.KANJI});
		} else {
			c.getInputContext().setCharacterSubsets(null);
		}
	}
}

